Introduction

Welcome to RenderPass Manager.

Concepts
Features
Rollouts Overview
Limitations and Bugs
3rd Party Renderer Support
How To: explanations of workflow and features.

RPManager is an extension of 3dsmax, intended to make the task of managing multiple render 'passes' from a single scene file easy and User Error free.

What is a 'Pass' and why would you want to render you scene out to multiple passes? Look here for a description.

Some of the problems RPManager was designed to over come are obvious, some not so obvious:
The 3dsmax render dialog only has two slots - production and draft (and only one in 3dsmax6) - which is simply not enough for the most basic of serious production work. More importantly, these two slots only store a certain amount of information - output path, render resolution - and not the amount of data that is needed for a complete pass - camera settings, object properties, object visibility, background setup, etc.

Traditionally the user will either use a single file and manually edit parameters/scene setup to output the desired passes, or break the scene out to multiple files - which makes editing a chore and prone to error as the files need to be synchronised, usually manually. Both these methods allow too much chance for User Error and take up large amounts of time, especially at the end of a job where many small tweaks are often required.

RPManager overcomes many of these problems in two ways: firstly it allows unlimited render passes, and secondly it brings almost all render parameters into the one interface. The few less used in (a per pass sense) render parameters not included in the interface can be controlled through the BeforePass and AfterPass scripts - if you need something done per pass and it is not in the interface and it is scriptable, then RPM can still control this on a per-pass basis.

RPManager is a complex interface, there are over 30 rollouts and dialogs, and hundreds of individual controls. This help explains each rollout individually before moving on to case studies. There are also some screen captured avi's of RPManager in use to get you started.


RPManager Feature List

RPManager's extensive feature list is based on the result of being developed in a production environment:

• Interactive and Integrated Pass Management system - single click restoration of complete pass setup.

• Unlimited Render Output setups (passes) per 3dsmax scene:
Each pass supports individual
- Output Path, Frame Range, Resolution, Options, etc.
- Camera Assignment
- Multipass Camera Effect settings
- Renderer Parameters (including 3rd party renderers)
- Network submission priorities
- Render Effects
- Atmospherics
- Background Color, Background Map and enabled state, Ambient Light
- Network Submission Priorities
- Xref Scene control (see below)
- Object visibility
- Object Properties

• Visibility Set System - build and manage object visibility sets for use with RPManager, assigned on a per pass basis, with tools for quicking adding/removing/redefining visibility sets. Objects can be members of multiple sets.

• Object properties per pass, includes Capture Sets with Material Override per pass. Properties include all standard object/light/camera properties ie material, visible to camera, light multiplier, etc (82 default properties supported). as well as support for 3rd party object properties if maxscript access exists. Ability to enter manual properties to support advanced features like Custom Attribute values per pass (value and color supported - baseobject custom attributes).

• Render Parameter Warning System - Configurable, warns for:
missing output path, duplicate output path, unusual frame ranges (Nth frame, single frames, <5 frames, skip existing on), mixed frame ranges, non-black or almost black background, animated background/ambient color, mixed output sizes, Visibility Set assignment potential problems, pass suspended, among others.

• 3rd party renderer support - tested with Brazil, Vray, MentalRay (final render support unknown - at this stage)

• 3rd party renderer multiple pass parameter editing - where MXS access is available, this is a custom rollout exposing a number of the renderers parameters to allow editing multiple passes renderer parameters simultaneously. Parameters not in this rollout can be edited in the standard rendering dialog on a pass by pass basis.

• Before/After pass scripts - to take care of any custom or special parameters on a per-pass basis, or to perform any scripted function.

• Xrefs Scene settings per pass - includes material override for xref scenes and alternate paths per pass. Material override has proved to be extremely useful in production.

• Xrefs Scene Deferred Loading - xrefs are disabled in the working scene to speed opening and interactivity, and are enabled only by the netrendering server when the scene is opened to render, so the user need never wait for heavy xrefs to load.

• Preview override system for efficient preview renders with select rendering options disabled, ie camera multipass effect off, lower resolution frame, advanced lighting off, shadows off, AntiAliasing off, (optional) visual indicator of preview mode rendered in the image. Overrides for 3rd Party Renderers such as Brazil and Vray include GI disable, reduced GI rate, DOF disable, motionblur disable, AA rate, shadows disable, among others. Network or local render output can optionally use these settings for rendering preview sequences.

• Preview History: user configurable number of history items (rendered preview frames) and location for preview history. Preview frames can include optional info stamp - scene name, time/date, render time.

Additional Features

• Render Elements Per Pass. The full RE setup is stored and restored, and can be saved/restored for reusing setups. Includes a render element output path inspector.

• Streamlined network submission of all passes - can be a single click for all passes.

• Auto Output Path generation with customisable scripted function for path creation.

• Optionally sets active time range to the passes output frame range for improved feedback.

• Output path inspector for viewing all output paths simultaneously, and editing of paths.

• RLA/RPF channels and output parameters storing/restoring per pass (recompiled rla.bmi)

Viewport/Render Scene Parameters restoration independant for streamlined workflow.

• External Ascii Data for editing output and some scene parameters external to 3dsmax and your scene, can be auto loaded on scene open.

• Network Manager controls for submitting to selected servers on a per pass basis, custom local server groups and the ability to import and use the Managers Global Groups.

• Scanline Radiosity setup per pass (ie lighttracer or radiosity state and settings)

• Default Raytracer settings per pass.

• Global Notes/Notes per pass for recording and describing setup - auto creation time stamped.

• Interface driven by tab system which allows multiple tab selections, tab presets, tab preset management tools, and the abiliity to lock the tab selection.

Export/Import partial setup parameters (common parameters, pass names, render effects/atmospherics, some renderer parameters)

• Ramplay a rendered sequence or view current times rendered frame from an easily accessible RC menu.

• Basic integration with Iridas FrameCycler for loading rendered sequences from a RC menu.

• Copy rendered frames to a specified directory from within the interface, or easily 'Explore' the directory containing your frames from a RC menu saving directory navigation time.

• Always warns if non-full frame rendering is specified on render submit - region, selected etc - avoiding incorrect rendered images.

• Auto creation of directories as needed when paths manually typed in rather than using the image browser.

• Callback Script control to automatically add callbacks to network submissions on a per pass basis - ie to do operations that only needs to be performed before a render by the render slave, such as having high resolution xref scenes swapped into the scene.

• Network Managers per pass, with stored list of managers for quick retrieval for studios with multiple or moving managers.

• Automatically build Digital Fusion 'seed' flows based on your passes (requires Eyeon Software's Digital Fusion 4)

• Quick Compositor for previewing your passes composited together and save time jumping from app to app.

• Integration with max Layers - use them as visibility or capture sets.

• Tabbed interface which allows multiple tabs to be selected an once, tab selection presets can be saved.

• Preset system to load and save setups and setup components.


Important Concepts

RenderPassManager Important Concepts

There are some points about the way RPManager operates that are important to understand.

A Render Pass - or just a 'Pass' or 'Passes' - is a set of parameters that define how 3dsmax renders an image sequence. Camera to use, what objects are visible in the scene, what environment effects are active, render effects that are active, output path, resolution, etc. The full version also allows controlling object properties per pass - material, visible to camera, lights on/off, etc. Through the RPM interface you create passes and define the settings for each pass.

Some parameters are still edited through the standard max UI - ie renderer setup (some renderer parameters can be controlled through the RPM interface), environmental/render effects parameters; and some parameters are edited throught the RPM UI - ie pass creation and various settings for the passes.

Each Pass must have a camera assigned to it, perspective views are not supported. A camera will be created automatically if your view is non-orthagonal and no cameras exist in your scene. The same camera can be used for all passes, or each pass can have any camera in your scene assigned.

Visibilty Sets can be assigned to Passes, these define what objects will be visible in the scene when that pass is rendered. You must be careful when creating new objects or merging objects - by default they will not be part of a Visibility Set, and may be hidden automatically. For new or cloned objects you can turn on the 'Auto Add New to Selected Visibility Sets' mode which automatically adds them.

There are 3 ways to render through RPM: a preview render of one or more passes, a local render, or via network submission. Buttons to render in any of these ways are always visible in the RPM UI, as is the main pass list.

RPM allows you to manage multiple passes, and also edit multiple passes simultaneously: there are some limitations to the display of the parameters when multiple passes are selected.

3rd Party renderer support:
3rd party renderers are fully supported by RPManager on a renderer-setup-per-pass basis, with the limitation being that you cannot edit multiple renderer controls - those particular to the renderer - simultaneously for all 3rd party renderers, you need to edit them on a pass-by-pass basis. Current support for multiple renderer editing includes Brazil and Vray, but this does not mean that RPM does not work with FinalRender or MentalRay. For example, in a scene where 3 different passes using MentalRay have different antialiasing sampling setup, to change them all you would need to restore each pass and change the parameters individually. With Vray and 3 passes that have different AA settings you could simply select all passes and edit the parameters in the 'Renderer' rollout in RPM.

As 3rd party renderers add more external control to their parameters RPManager will be updated to allow editing multiple renderer parameters at once through customised rollouts - much like the 'Default Scanline Parameters' does now with the default scanline renderer.


What Is a Render Pass and Why Do I Need Them?

There are a number of reasons you may want separate render passes from a 3dsmax scene:

a. You want to break out the elements into background/midground/foreground to control Depth of Field.

b. You want to render your scene from multiple cameras, to multiple outputs.

c. You want to break your scene into separate image sequences so you can composite the shot in a 2d compositing package to control integration with live plates to a level not possible within 3dsmax itself.

While RPManager will help with any of the above scenarios, it has been designed from the perspective of point c. - breaking a scene down to elements that enable as much control as you want and need in a 2d compositing package.

What is a Render Pass in the context of this help? A render pass is effectively the collection of settings that define what is needed to produce a single image sequence - ie camera to render from, output path to render to, what is visible and what properties all these elements have.

Separate Renders From My Scene - Why Do I Need Them?

Chances are that if you are at all excited about what this script can do for you, you will already know why you need them - control, and, ultimately, reduced render times.

Control: you want to produce photoreal work. Lets say you are using subsurface scattering in your 3rd party renderer, but find the render times are pretty high, and you are still tweaking lots of parameters.

So you decide to break out your translucency, and rather than let the renderer composite the final image, you will do that yourself. You render the translucency once, your diffuse pass once, your reflections once. You comp it in your 2d package, and then you can grade each element separately to adjust your final image. Need more or less translucency? Drop a gain tool and tweak it in almost realtime.

This sort of level of control is why rendering in passes may well be worth the effort.

Reduced render times:

How can this save you time when you have to do 10 renders, and then spend time setting up the composite?
Having your scene broken down into elements can save a huge amount of time when initially setting up the look you want, and especially when needing to make changes late in a project; if the reflection component of a shot is found to be too strong and you have the reflection as a separate pass, changing the intensity of the reflection in 2d and re-rendering the output is a trivial and usually extremely quick process; re-rendering an entire shot in 3d is often a matter of hours.


Tabbed Rollouts Overview

RPManager's interface is built around tabbed rollouts, each containing controls and information about a particular section of the rendering pass system.

There are two parts to the interface - the main Pass List and associated controls that are always visible, and a set of rollouts that the user can display at need.

The tab system enables multiple rollouts to be displayed at once, as well as the ability to lock the current tab selection, and setup and restore presets of tab selections; described here.

The Pass List and associated controls is where passes are managed and interactivity controlled, described here. These controls are always visible as they are essential to the workflow.

The following links explain each of the rollouts in detail.

Per Pass Common Parameters
Renderers
Default Scanline Parameters
Render Elements (Scanline)
Render Effects Per Pass
Atmospherics Per Pass
Network Render Setup
Object Properties Per Pass
Xref Scene Support
Callbacks for Netrender Submission
Before Pass/After Pass Scripts
Preview Overrides
Quick Compositor
Render Submission Alert Setup


RPManager Passes Main Controls

This is the Main rollout in RPMangager - where you create, delete, assign visibility sets, set active and generally manage your individual render passes.

A 'Render Pass' is a set of information that makes up an output from a scene, in the case of RPManager that information is output path, image resolution, what objects are visible, what properties those objects have, what xref scenes are enabled, background color/image, multipass camera settings, etc.

In some ways it is similar to the draft and production settings in the default 3dsmax render dialog where you have two separate render setups - but with literally hundreds of additional parameters that make up each pass.

Passes List Display:
This Displays a list of the Passes in your scene, showing pass name, which visibility set is assigned to the pass, as well as how many Render Effects and Atmospherics are active for each pass. This is where you do much of your pass management.
Tip: This list can be vertically resized to optimise the space used, using either the 'Fit' button or the small '+' and '-' buttons (see image to right) to the right of the column headers. You can also drag and drop passes to reorder them.

Pass Name:

Global Parameters:
Pass Management Buttons + Scene Submission Prefix:
Render Effects Active Status:

This area is where you assign and manager visibility sets - the interaction is through a Right Click menu, shown scaled down to the right. A description of the menu contents can be found here.

These two parameters display the passes output time type and frame range so that at a glance you can see your passes output ranges:
If active time range or specified time range a start and end frame number is displayed;
If single frame, current frame, then the first parameter displays 'Singl' and the second is blank (as in the image above);
If single frame, specified frame, the first parameter displays 'Singl', the second the specified frame number;
If a non-contiguous frame range is specified then the first parameter displays a 'Non.' and the second 'Cont.'.

This is the descriptive name for the pass. Right click on the pass name to bring up a menu, shown scaled to the right. A description of the menu contents can be found here.

Start & End frame range reporting:
Visibility Set Assignment:

This column reports which renderer is assigned to the pass.
A RC menu is activated when Right Clicking in this area, shown to the right, which allows to to change the assigned renderer, load a renderer preset, or copy/paste a renderer. A description of the menu contents can be found here.

This simply reports how many of the existing Atmospherics are active for this pass.
A simple RC menu is activated when Right Clicking in this area, shown to the right:

This simply reports how many of the existing render effects are active for this pass.
A simple RC menu is activated when Right Clicking in this area, shown to the right:

Active Renderer:
Atmospherics Active Status:
Note: Click on a region in this image to be taken to information about that control

These buttons, left to right are:

Add Pass - adds a single pass to the end of the list. The list height will be resized if it currently matches the height of list items.
Duplicate Selected Passes - duplicates selected passes, the passes are added below the pass they are duplicated from with 'Duplicate' appended to the name.
Delete Selected Passes - delete one or more passes at once. No undo for this operation (a confirmation dialog is shown).
Move Selected Pass(es) Up in List - You can also drag and drop passes to reorder them.
Move Selected Pass(es) Down in List - You can also drag and drop passes to reorder them.
Fit the List to the number of passes - this vertically resizes the list to match the number of passes. Note you can also use the small '+' and '-' buttons to the right of the column headers to resize the list.
Quick Select All - all passes are selected in the list, but no visiblity sets are restored or other params restored so this is very quick.

The Scene Submission Prefix is text that is prefixed to the name of the pass when submitted for a Network Render, usually used to store the shot or scene name - so two separate scenes, both with a Pass labelled 'BG elements' will not be identically labelled in the Render Queue after submission.

These controls determine both how a pass is restored in the viewports - as you click on a pass to restore its parameters - as well as how the passes are rendered, and which viewport the camera of a pass is restored to.

For speed of interaction you can turn Visibility Set restoration, Object Property restoration and whether the Before/After Pass scripts are run off - with separate controls to determine if these pass properties are restored for rendering. If Render time restoration is off then Viewport restoration is disabled.

The 'Ignore Non-renderable for visibility' option controls whether visibility set restoration will ingnore or include non-renderable classes - helpers, cameras, lights - as these may be included in a Visibility set but you will often want them to be persistently visible in your scene.

The small button highlighted in red minimises/maximises these controls to optimise the UI.


RPManager Pass Name RC menu

Digital Fusion - load selected passes:

Explore Render Directory...: the opens an explorer dialog at the location of the passes output path.

Copy frames defined by sequence to...: this brings up a directory requester, which will copy the rendered frames, defined by the passes output range, to the location specified.

Restore Pass: This forces the selected pass to be restored. Not available if more than one pass selected.

Netsubmit Checked: This netsubmits all checked passes.

Preview Checked Passes: This does single frame previews (current time) all checked passes.

Render Checked Locally: This render the checked passes locally. If 'Netrender' is enabled for any passes it will bring up the standard max netsubmit dialog for that pass.

Netsubmit Selected: This netsubmits all selected passes.

Preview Selected Passes: This does single frame previews (current time) all selected passes.

Render Selected Locally: This render the selected passes locally. If 'Netrender' is enabled for any passes it will bring up the standard max netsubmit dialog for that pass.

Check Tools: This submenu contains shortcuts to check or uncheck passes en masse.

Pass Selection Tools: This submenu contains shortcuts to select or deselect passes en masse.

Rename: Allow you to rename a pass. A shortcut for this is to Double Click the pass name, or use F2.

Add Pass: adds a pass to the end of the list.

Duplicate Selected: duplicates the selected passes, the new passed appear directly beneath the pass duplicated.

Add Pass, create visibility set from Selected: This creates a new pass and Visibility Set from the selected objects in your scene and assigns this set as the passes visibility set- it automatically names the new visibility set.

Add Pass, create visibility set from Visible: This creates a new pass and Visibility Set from all visible objects and assigns this set as the passes visibility set- it automatically names the new visibility set.

Delete Selected: Delete the selected passes from RPManager. This is not undoable.

Ramplay Pass, current range: This loads the passes output defined by the passes range into the ramplayer if the rendered frames exist.

Frame Cycle Pass:

View Current Frame: this views the current (scene) times frame rendered image if it exists.


RPManager Visibility Set RC menu

Create Visibility Set: This brings up the Create Visibility Set dialog, see here for details.

Isolate This Visibility Set.: Available if one pass selected only, this isolates the current passes visibility set - ie if restore in viewports is off then use this to isolate the current pass.

Manage Visibility Sets: Brings up the Manage Visibility Sets dialog, described here.

Auto Add New Objects to Selected Passes Visibility Sets: When this mode is enabled - indicated by the check mark - newly created and cloned objects are automatically assigned to the selected passes Visibility sets. Defaults to Off, set this default in the Global Defaults.

Isolate Set when Objects Added/Removed: When this mode is enabled - indicated by the check mark - the selected passes Visibility Sets are isolated, showing you what these visibility sets contain. Defaults to Off, set this default in the Global Defaults.

Hide Visibility Set Members: this hides the objects that are in the sets assigned to the currently selected passes.

Unhide Visibility Set Members: this unhides the objects that are in the sets assigned to the currently selected passes.

Select Visibility Set Members: this selects the objects that are in the sets assigned to the currently selected passes.

Delete Visibility Sets, selected passes: this permanently deletes the visibility sets assigned to the selected passes.

Select/Show renderable objects not in Visibility Sets: this unhides and selects all objects that are in a renderable class (ie not lights, helpers and cameras) that have not been included in any Visibility sets.

Add Selected Objects to Visibility Set(s): This adds the currently selected objects to Visibility sets assigned to the currently selected passes. This item changes to 'Create Visibility Set' (see below) if a pass with no existing Visibility Set selected.
If the 'Auto Add New Objects...' mode is not on then you will need to add newly created objects to the relevant Visibility Sets, else they will not be visible in the render. This is a quick way to do this.

Remove Selected from Visibility Set(s): removes the currently selected objects from the Visibility sets assigned to the currently selected passes.

Visibility Set(s) redefined to objects currently visible: This redefines the selected Visibility Sets to equal the objects that are currently visible in your scene.

Assign a Visibility Set...: This is a submenu displaying the current visibility sets in the scene, picking assigns to the selected passes.

Clear Visibility Set Assignment: This removes visibility set assignment from the selected passes.

Set To Nothing: This is a special visibility set which hides everything.

Set To Everthing: This is a special visibility set which unhides everything.


Visibility Set Manager

Add Selected Objs: This adds the objects currently selected in your scene to the selected visibility sets.

Remove Selected Objs: This removes the objects currently selected in your scene from the selected visibility sets.

Assign Objects to Set...: This brings up a Select By Name dialog where you can pick objects to add to the selected visibility sets.

Remove Objects from Set...: This brings up a Select By Name dialog where you can pick objects to be removed from the selected visibility sets - the list only shows objects that are assigned.

Redefine as Visible: This redefines the selected Visibility Sets to equal the objects that are currently visible in your scene.

Redefine as Selected: This redefines the selected Visibility Sets to equal the objects that are currently selected in your scene.

Delete Set(s): This deletes selected visibility sets. Note there is no undo for this operation.

Import Selection Sets: This brings up a dialog allowing you to import your Selection Sets as Visibility Sets. Duplicate names are not allowed and will be skipped on import.

Export as Selection Sets: This builds Selection Sets that match your Visibility Sets - if Selection Sets of the same name exist an overwrite prompt will appear.

The Visibility Set Manager is where you can create, rename and generally manage your Visibility Sets. It can be accessed either through the 'VisibilitySets' menu, or in the RC menu of the Visibility area of a pass in the main RPManager interface.

A Visiblity Set is much like a selection set - it is simply a collection of objects that RPManager can assign to a pass, to define what is visible in the scene when that pass is rendered. An object can be a member of any number of visibility sets, unlike the Capture Sets.

Create New Set: This creates a new empty set, with a default name.

Select Members, Selected set(s): This looks at the currently selected Visibility Sets in the list box in the dialog, and selects, in your scene, the objects that are members of those sets. It is a good visual way to see what is in a set or sets.

Isolate Selected Set(s): This hides everything in the scene except those members of the currently selected sets.

Unhide Selected Set Members: This unhides all members of the sets selected in the list.

Hide Selected Set Members: This hides all members of the sets selected in the list.

Unhide All Sets: This unhides all objects included in any Visibility Set.


Import Selection Sets

This tool is used to import your Named Selection Sets as Visibility Sets.

Check the items you want to create as Visibility sets, and use the 'Import Checked' button.

The Objs column reports the number of objects in the listed Selection Sets.

If a Visibility Set of the same name already exists a warning is shown and that Selection Set is skipped.

The All and None buttons simply check/uncheck all the list items.


Renderer RC menu

The items at the top of this menu is a list of the currently installed renderers.

Copy Renderer/Settings: Places the selected passes renderer into a copy buffer. You can only copy a single passes renderer at a time.

Paste Renderer/Settings: This pastes the copied renderer into the selected passes - you can paste into multiple passes.

Save Renderer Preset...: This allows you to save a selected passes renderer setup for later loading.

Load Renderer Preset: This submenu contains an item to allow you to open a preset from anywhere, as well as listing all the currently saved presets in the renderer presets directory.


Per Pass Common Parameter

Per Pass Common Parameters

This is where you control the Common parameters of each pass. This is similar to the Default Renderdialogs 'Common Parameters' rollout with some important additions: per pass control of Environment settings, Multi-pass Effect settings, and Netrender submission priority settings.

Most of the controls will be familiar to you from the default render dialog, so I will simply single out the differences:

Time Output:
This is where you set your frame ranges for the pass. The 'Use Current Time' checkbox along with a spinner for the 'Single' output setting allow you to define which single frame should be rendered, rather than just using the current frame. Turn the 'Use current Time' option off and then set the single spinner to a value for this to be active.

Output Size:
The only real update with this is that the 'Aspect' parameter is reported and not an editable value.

Render Setup/Primary Output Path:
This is the equivalent of the 'Render Output' group of the default render dialog, with some additions:

  • The 'Strip Pad.' checkbox which if active strips %4d padding (4 number padding) from the output, which means you can select an existing frame, say 'out0024.tga' and it will be stripped back to out.tga.
  • The 'Auto' button which will ask for a directory and file extension only - and then, for any selected passes, it will create directories with the same name as the Pass, and outputs with the same name as the Pass. See the 'Output Paths' menu for more output path options.
  • The 'G' button gets the render dialogs output path (useful if the scene has been setup previously without RPManager)

Options:
Identical in functionality to the default render dialog 'Options' group.

Environment:
This is new common parameters functionality - per pass control of background color (including animated BG color), background map, background map active/inactive, and ambient color (inc. animated ambient). The 'G' button gets the currently selected map from the Material Editor and puts it into the map slot, the 'P" button puts the Environment map into the currently selected slot in the Material Editor.

Multi-Pass Effect Settings:
This is new common parameters functionality - per pass control of camera Multi-Pass effect settings, so you can control Multipass motion blur, depth of field, or 3rd party multipass effects on a Per Pass basis.

  • The 'Capture' button gets the current cameras multipass settings, use if you have set this in the camera and not in the RPManager interface.
  • The 'Preveiw' button previews the multipass effect in the viewport - same functionality as the Preview button in the cameras multipass effect controls.

Camera and Netrender Priority:
This is where you define which camera is assigned to the Pass, network submission priority for the Pass, critical priority, and whether or not the Pass will be submitted Suspended.

Advanced Lighting:
Identical to the default render dialogs Advanced Lighting group.

Netrender Callback:
This is a toggle for whether or not the Netrender Callback, if defined, is active for this pass. This cannot be toggled on if not Netrender Callback has been defined.
See the 'Callbacks for Netrender Submission' Rollout for more information.


Renderers Rollout

This is where you control which renderer is assigned per pass.

Production and Draft per pass is supported, but should probably be considered redundant as there is no real advantage to using one or the other for any pass.

The 'Open Render Dialog' button opens the render dialog where you can then edit the renderer parameters for the current pass - note that you can only edit a single passes renderer settings at a time- selecting multiple passes and then editing the default render dialogs renderer settings will have no effect on RPManagers data.


Default Scanline Parameters

These controls duplicate the 'Max Default Scaline A-Buffer' controls in the default render dialog - for single pass editing of renderer parameters you can use either these controls or the default dialogs controls - but for editing multiple passes renderer settings you must use these RPManagers controls. Selecting mutliple passes in the pass list will disconnect the default render dialog from affecting any passes settings.

The Global Raytracer Settings and Advanced Lighting groups allow you to control these parameters on a pass by pass basis. Global Raytracer settings are either global or per pass, controlled with the radio buttons in this UI group.


Render Elements

These controls duplicate the 'Render Elements' rollout in the default render dialog, with some interface changes:

  • Blend Elements parameters and Z Element parameters are not rollouts that appear as needed, these controls are always visible and enabled/disabled as required.

And some additional controls:

Add brings up the add render element dialog, described here.

Build Outputs automatically builds output paths, if the main output path for the selected passes has been set, and as defined by the RMbuildOutputPaths.ms functions, described here.

Paths... opens the Render Element Path Inspector.

Delete deletes the selected render elements. There is no undo for this operation.

S (Save) allows you to save out the data for loading into other passes/other scenes.

L (Load)brings up the Render Element Merger dialog.

NOTE unlike the Render Effects or Atmospherics this list is completely rebuilt for each pass. You cannot edit multiple passes render elements at once, although you can add elements to multiple passes simultaneously: note there is no visual feedback when you do this, the list is disabled when multiple passes are selected.


Render Effects Per Pass

These controls allow you to determine on a per pass basis which render effects are active.

The list of what render effects are in the scene is not rebuilt on a per pass basis - what is updated is the active/inactive state of each of the effects, and this is controlled using the Checkboxes next to each entry.

The Class column is so you can rename your effect and still see at a glance what type of effect it is, and the Dur column simply reports Motion Blur duration.

What you need to set for each pass is the checboxes for the effects.

Color coding:
Blue is an inactive effect for this pass.
Red is and active effect for this pass

Reload Effects: rebuilds the list of atmospherics, when you add an atmospheric via the 3dsmax Environment Dialog you either need to use this or click in the atmospherics list control to update the atmospherics shown.

Open Effects Dialog: this opens the Render Effects dialog.

Add Effects: brings up a dialog where you can add render effects. You will still neeed to use the 3dsmax render effect dialog to edit effect parameters.

Edit Selected: this opens the Environment Dialog with the selected Atmospherics controls ready for editing.

All On...: this brings up a menu seen to the right, the first option checks all Atmospherics in the current pass, the second checks them all in all passes.

All Off...: this brings up a menu seen to the right, the first option unchecks all Atmospherics in the current pass, the second unchecks them all in all passes.

Delete Selected: this deletes selected render effects.

There is a Right Click Menu for the list in this dialog:


Atmospherics Per Pass

These controls allow you to determine on a per pass basis which render effects are active.

The list of what atmospherics are in the scene is not rebuilt on a per pass basis - what is updated is the active/inactive state of each of the atmospherics, and this is controlled using the Checkboxes next to each entry.

The Class column is so you can rename your effect and still see at a glance what type of effect it is.

What you need to set for each pass is the checboxes for the effects.

Color coding:
Blue is an inactive atmospheric for this pass.
Red is an active atmospheric for this pass

Reload Atmospherics: rebuilds the list of atmospherics, when you add an atmospheric via the 3dsmax Environment Dialog you either need to use this or click in the atmospherics list control to update the atmospherics shown.

Open Envir. Dialog: this opens the 3dsmax Environment dialog.

Add Atmos...: brings up a dialog where you can add atmospherics. You will still neeed to use the 3dsmax Environment dialog to edit atmospheric parameters.

Edit Selected: this opens the Environment Dialog with the selected Atmospherics controls ready for editing.

All On...: this brings up a menu seen to the right, the first option checks all Atmospherics in the current pass, the second checks them all in all passes.

All Off...: this brings up a menu seen to the right, the first option unchecks all Atmospherics in the current pass, the second unchecks them all in all passes.

Delete Selected: this deletes selected render effects.

There is a Right Click Menu for the list in this dialog:


Object Properties per pass

This rollout is where you setup and control object properties on a pass by pass basis.

Object property capturing and restoring works within the concept of a 'Capture Set'. A capture set defines what objects are controlled by the set, and what properties for those objects that are controlled. This allows you to only capture the properties you want, for the objects you want.

Unlike visibility sets, objects can only be in one capture set at a time - adding it to another set will remove it from the set it was a member of (appropriate warnings and options to cancel are given along the way).

In addition to being able to have pass-specific materials on objects (by capturing the material as a property) you can associate a material with a capture set which will apply the material to all set members - a quicker way to mass assign materials per pass.

The workflow for using the object properties is:
1. Create a set
2. Add objects to the set
3. Define what properties that the set controls.

(Note that steps 2 and 3 can be interchanged, and you can add or remove both objects and which properties the set controls at any time.)

When you first add objects to a set that has properties defined, or when you define properties for a set that has members, the current state of the properties for the member objects is captured for every pass; this gives you a captured 'starting point' for every pass.

From there you can select one or more passes, set the properties on the object to what you need for that/those passes, and use one of the capture buttons (selected, selected set, or all objects in capture sets) to make any new properties 'stick' and actually capture them. If you are setting up individual passes you can turn on the 'Auto Capture Props' checkbox - this will automatically capture the properties of all objects in capture sets when you change passes: this mode only works when selecting/restoring individual passes but makes for a fluid workflow.
IMPORTANT: if you change object properties for member objects and do not capture using one of the methods you will lose your edits when you come back to this pass.

After your properties are captured for your specified objects the properties will be automatically restored when you restore passes or submit renders. Object property restoration for large numbers of objects can slow down pass restoration, so in the 'Global viewport and render parameters' controls below the main pass list there is the option of disabling object properties in the viewports: it is still on for all previews and renders. From this same group it may be disabled for previews and renders as well.

See here for a tutorial for object properties.

Rollout Controls Explained:

Set Management
Create Set: this button creates new sets. If objects are currently selected it offers to add those objects to the set. New sets are created without any properties defined.

Define Properties: this button brings up the the dialog where you define what properties the set captures. See here for a description of these controls.

Duplicate Set: use this to duplicate a selected set. Note that this duplicates the set creating a new set with the same defined properties, but does not add any objects to the new set - it is created empty.

Delete Set(s): This deletes the selected sets. Any objects that were part of the sets that have been deleted lose their captured property data.

Set Member Management
Add Selected Objects: this adds all selected objects to the currently selected set. If multiple sets are selected it adds the objects to the first set selected. If objects are already part of a different set the object is moved and any properties not already captured are captured and properties that are no longer needed are removed.

Remove Selected Objects: this removes the selected objects from the selected sets. All object property data is removed from the objects including the initial capture state. Either leaving the object with the current properties intact or restoring the objects properties to the values prior to adding the objects to a capture set is offered after an initial confirmation dialog.

Add By Name: this brings up a select by name dialog allowing you to add objects to the currently selected set by name.

Remove By Name: this brings up a select by name dialog allowing you to remove objects from the currently selected set by name.

Clear Set Members: the removes all objects from the currently selected sets. A dialog offers to restore the objects properties to their initial state or leave the current properties intact (all captured data is removed from the objects).

Capture Data Management
Capture Selected Objects: this captures the current properties for the currently selected objects, for any properties that are defined for the sets the objects are in. This does not affect any selected objects that are not in capture sets (it does not matter that they objects not in sets are selected). This is the fastest way to capture object properties if you are working with a small number of objects.

Capture Selected Sets: this captures the current properties for all objects in the selected sets, regardless of whether the objects themselves are selected.

Capture All Objects in All Sets Properties: this captures all objects in all sets regardless of whether any sets are selected: it is a global 'capture everything that is set up to be captured' button.

Select Members in:
Selected Set: selects the member objects in the currently seleced set(s).

All Sets: selects the member objects of all sets.

Unhide Selection: simply unhides any selected objects that are hidden.

Query Selected: reports whether the currently selected objects are members of capture sets or not, and offers to either deselect uncaptured objects (leaving you with just objects that are captured selected) or deselect captured objects (leaving you with uncaptured objects selected), or cancel and leave the current selection intact.

Select Members on set selected: when this checkbox is enabled selecting a set in the set list selects the member objects.

Restore All Object Parameters: this restores all object properties for the current pass - it restores the object properties as if you restored the entire pass. If you have modified any object properties and have not captured those properties using this will restore the properties that are actually captured.

Open Capture Floater: this opens a small floater to make capturing properties more convenient. See the description here.

Material Override - all object in Capture Set
These controls allow you to set up a capture set material override. This can be a more convenient way of controlling materials for large numbers of objects, ie for matte passes etc. This works in conjuction or separately from the capture set material property.
Defining an override material for a set is a matter of choosing a material while one or more sets are selected. The G(et) and P(ut) buttons allow you to get materials from the Material Editor and put materials to the Material Editor. These work with the currently selected slot in the material editor (note: due to a limitation in Maxscript drag and drop is not possible). The checkbox in these controls can be used to easily enable or disable already defined materials.

Capture Globals
Restore Properties Active: this checkbox controls whether properties are restored for previews and renders, and mirrors the control in the main global controls.

Auto Capture Props - only if single pass selected: if this checkbox is selected all object properties defined for all members of all sets is captured whenever you change pass or preview/render, allowing you to modify object properties without having to remember to capture anything. The drawback is that this can be slow with many captured objects.

Capture Materials as Instances: with this checkbox enabled materials and animated properties are captured as instances: use this very carefully as when this is enabled it is easy to have a single material instanced across multiple passes (which while sometimes very useful but can be very dangerous).

Restore Materials and Animated Props as Instances: with this enabled (the default) materials and animated properties are restored as instances. What this means is that the material or animated property that is restored to the object is an instance of the material or property that is stored - so when you modify the (say) material after it has been restored there is no need to re-capture it.

The recommended workflow is to leave capture as instances off and restore as instances on. Once you have captured the materials or other properties restore the pass and then modify the material if it needs to be worked on.

S


Object Props Menu

Object Properties Capture Set Parameters Definition

Selected Objects Parameters: this captures the properties for the selected objects, for the selected passes.

All Objects Parameters: this captures the properties for all objects, for the selected passes.

Auto Capture Props: this enabled or disables the auto capture mode - where properties are captured when the current pass is changed, or a preview/render is requested. Mirrors the Auto Capture Properties checkbox in the Object Properties rollout.

Restore Mat/Ani as instances: determines whether materials and animation are restored as instances - if restored as instances then recapturing after editing is unnecessary, this parameter is usually on. Mirros the similarly named checkbox in the Object Properties rollout.


Before/After Pass Scripts

RPManager provides an interface for most of the tasks involved in setting up multiple passes within 3dsmax, but there are times when more control is needed, or 3rd party or in-house tools need to be controlled, and this rollout provides one of the ways to do this (the custom rollout is another, as is the callbacks per pass).

If the property of the render can be controlled via MaxScript, then this rollout can be used to make the calls required. In the above example the before script turns of the PFlow particle system, and the after script turns it back on again.

The Before script is the script that is run when the pass is restored.

The After script is the script that is run when a different pass is restored and is most often used to 'undo' the change made with the before script.

The Test buttons simply run the script as it is entered and will tell you if it errored.

The fileIn... button brings up a file selector dialog and then enters the appropriate fileIn command at the insertion point.

Note: enter commands here as you would in any maxscript editor, ie do not use \" for quote marks (unless as part of a string), and use semicolons (;) to separate commands. If your commands are more than comfortably fit into the fields it makes sense to use the filein to load a pre-saved .ms file or to call a pre-defined function. The fields allow almost any amount of text but will not show a scrollbar when more text is present than is visible.

You are not just limited to calling object properties, this can call anything - ie a maxscript function you have written that creates custom bitmaps and assigns them to materials, or to execute a complex external script that has been previously setup. Note that this script does not need to be available on the network as it is restored at the time the pass is submitted.

*If you want to have a script run for a pass by the network slave itself so that time on the local machine is not wasted use the 'Callbacks for Netrender Submission' controls to set up persistent callbacks that will only be run by the slave.


Preview Overrides

The screen capture here shows the preview overrides enabled - when enabled the controls affect the renders; resolution reduction, multipass camera off, render effects and atmospherics disabled, etc.

The Preview Overrides: Enabled/Disabled button disables or enables the preview override system.

Load Multiple Previews + Alpha into Ramplayer: if you are previewing multiple passes and this checkbox is enabled (this is not affected by the Preview Overrides global enabled state) all the passes previews will be loaded into the 3dsmax Ramplayers A channel as a sequence, with the alpha channels for each loaded into the B channel.

The middle group controls all renderers and as such only affects a few parameters.

Note that these checkboxes determine the disabled state of the parameter, so having 'Multipass Camera' checked means that this will be disabled for the render. This may change if enough people find the reverse logic too irritating.

The bottom group is renderer specific and changes based on the currently selected renderer. Below are shown the preview override controls for Splutterfish's Brazil renderer and Chaos Groups Vray renderer.

If there are some override controls that you feel are missing please email a request.

If a renderer does not provide MXS access or is not specifically supported the following will be seen.

One of the features of RPManager is to attempt to enable quicker preview renders of passes.

The way it works is to provide controls to turn off or dumb down features of the renderer for previews. Note: by previews we are talking about preview renders not animation previews - and specifically previews created with either of the two preview buttons in the bottom left of the RPM interface. This does not affect the use of 'render last' as the renderer properties are temporarily modified and restored when the preview is completed. The preview overrides can be enabled for RPM submitted local or network renders (for the purpose of fast test renders) from within the render submission dialogs.

The above image shows the preview overrides disabled - in this state preview renders created by RPManager are at full resolution etc.


Visibility Sets Overview

Object Visiblity per pass is controlled through 'Visibility Sets'.

A Visiblity Set is much like a selection set - it is simply a collection of objects that RPManager can assign to a pass, to define what is visible in the scene when that pass is rendered. An object can be a member of any number of visibility sets, unlike the Capture Sets, and unlike layers.

There are tools in the Visibility Set Columns RC menu to quickly and easily add objects to a visibility set, remove objects, redefine a set completely, or isolate/hide/unhide a set.

There is also a Visibility Sets Manager, which allows you to manage sets and their members.

You can also convert existing selection sets in your scene to visibility sets, via the Import Selection Sets dialog.


Create Visibility Set

This dialog sets parameters for creating a new Visibility Set.

Name Visibility Set: this is where you set the name of the Visibility Set - Duplicate names are not allowed and you must enter a unique name to continue. This defaults to the name of the pass.

Objects to Assign to Visibility Set: you can set whether the new visibility set's objects are defined as objects selected in scene, objects visible in scene, all objects or none - an empty visibility set.

Pass Controls: These two controls determine whether the new set is assigned to the currently selected passes, and if so should the set be isolated. The default behavior of these controls are set in the Global Defaults, and are also scene sticky.

TIP: Shift-Enter the Name Field after entering a name for the Visibility Set to auto-OK this dialog.


Customize Menu

Preferences... : this brings up a dialog that allows you to set some default parameters.

Remove All RPManager Data: This option deletes all the RPManager data that has been embedded in the scene, which removes any passes you have set up, and is not undoable.


Preferences

This is where you can set some defaults for RPManager settings, both for the current scene and for future scenes..

Save Merge Data With File: if this setting is on you can RPManager data from existing scenes by using the Xdata menu's 'Merge RPManager data from existing scene...'

Visibility Set Restoration Generates Undo: with this on the visibility set restoration (RPManager hiding and unhiding objects when passes are restored) generates an undo entry. This is slower, and not often used.

Auto Add New Objects to Current Visibility Sets: this sets default for the menu item described in the RPManager Visibility Set RC menu. This feature automatically adds newly created objects to the current visibility set.

Create Visibility Sets Apply to Current On: this sets the default for the option in the Create Visibility Set dialog. Newly created visibility sets are automatically assigned to the selected passes. Not often turned off.

Isolate Set when Objects Added/Removed: this sets the default for the option in the Visibility Set RC menu. This enabled or disabled visibility set isolation when objects are added/removed from the set - if you are doing a lot of adding/removing it is often useful to turn this off as you don't want the objects you are working with constantly hidden.

Isolate Set on Created and Apply to Pass On: this sets the default for the option in the Create Visibility Set dialog. This controls whether the visibility set is isolated when it is initially assigned to a pass.

Offer conversion of Production and Draft: this controls whether the first time RPManager is opened in a scene it offers to create two passes that match your production/draft setup.


Passes Menu

Add Pass: this adds a new pass to the pass list.

Duplicate Pass(es) : this duplicates selected passes.

Add Pass, create new visibility set from Selected: this adds a new pass to the pass list, and create a visibility set from the currently selected objects.

Add Pass, create new visibility set from Visible: this adds a new pass to the pass list, and create a visibility set from the currently visible objects.

Delete Pass(es) : this permanently deletes selected passes - no undo available.

Pass Notes...: this opens the Pass Notes dialog, where notes can be stored for describing and explaingin setup.


Pass Notes

The per pass notes allows you to attach information to each pass, as well as a global note to the scene.

Some note information is automatically entered when a pass is created - the date and time of creation, the username logged in, and the computer name.

To add to a note simply enter text into the right text field. Clickon a pass name in the left field to acces that passes notes.

The revert button undoes the most changes, and the export button allows you to export the notes.


Output Menu

Inspect Output Paths...: this open the Render Output Path Inspector where paths for all passes can be viewed and edited.

Auto Build All Paths...: this brings up a standard bitmatp requester dialog, from this you should pick a directory in which to build all the paths, and an output format for all the paths. The output format can be picked either from the dropdown list, or by entering just the dot-extension required (ie '.tga') in the name field.

Auto Build Selected Pases Paths... : this does the same as the above but for selected passes only.

Show Last Preview Frame: this displays the last preview frame rendered.

Show Last Preview Ramplay: this displays the last multiple-pass preview that the ramplayer loaded.

Explore Preview Directory: this opens an explorer window on the preview directory set in the output preferences.

Close all Extra RPM preview frames: this closes all extra preview frames (not the main VFB) - only relevant if previewing multiple frames and not having RPM automatically load them into the Ramplayer.

Ramplay Selected Passes Preview History: If you have preview history active, this will load all the preview history files into ramplayer, for all selected passes.

Delete Selected Passes Preview History: This deletes all the preview history files for the selected passes.

Output Preferences: this opens the Output Prefs dialog where you can control the preview history settings and frame stamp.


Render Output Path/Output Format Inspector

This dialog shows all your passes and pass outputs in one place, and allows you to edit individual paths, as well as providing control over the output setup of the specific formats.

This dialog is resizable, but will try to intelligently truncate paths that are too long to fit - as seen with the last line of the list in the image to the right.

To edit a path, select the pass/path in the upper list box, and then use the 'Browse...' button which brings up a bitmap selector, or click on the path field which puts it into edit mode - enter to complete the edit of the path.

To edit the output setups, right click on the parameter to want to edit and pick the value you want from the list. To edit TIF DPI middle click and drag the mouse to change the value. JPG Quality and Smoothing can be edited either from the right click menu, or middle-click dragging.

Not all output formats are controllable through this interface.

Note: control of RLA and RPF output setup requires that the recompiled rla.bmi that is included with RPManager be installed.


VisibilitySets Menu

Visibility Set Manager...: this opens the Visibility Set Manager.

Import Selection Sets...: this opens the Import Selection Sets Dialog.


Object Props Menu

Open Capture Floater...: this opens the ObjProp Capture dialog.

Capture Selected Object Properties: this duplicates the behavior of the 'Capture Selected Objects' button in the object properties rollout.

Capture All Objects Properties: this duplicates the behavior of the 'Capture All Objects in All Sets' button in the object properties rollout.


Object Props Menu

Object Props Capture Floater

Selected Objects Parameters: this captures the properties for the selected objects, for the selected passes.

All Objects Parameters: this captures the properties for all objects, for the selected passes.

Auto Capture Props: this enabled or disables the auto capture mode - where properties are captured when the current pass is changed, or a preview/render is requested. Mirrors the Auto Capture Properties checkbox in the Object Properties rollout.

Restore Mat/Ani as instances: determines whether materials and animation are restored as instances - if restored as instances then recapturing after editing is unnecessary, this parameter is usually on. Mirros the similarly named checkbox in the Object Properties rollout.


XData Menu

Merge RPManager Data from Scene...: this opens the RPManager Pass Merger dialog. You can only merge data from scenes that have the 'Save Merge data with file' enabled in the RPM preferences.

Save RPManager Data...: this allows to you save the RPManager data from the current scene, to be imported at a later date. You can use this to build basic setups that can be reused.

Load RPManager Data...: this allows to you load the RPManager data that you have saved with the 'Save RPManager Data...' menu item.

External Data Manager...: this brings up the External Data Manager dialog.

Save External Data Now...: this forces an immediate save of the external data.

Load External Data Now...: this forces an immediate load of the external data.


Pass Merger - extracting RPM data from existing scenes

The RPManager Pass Merger dialog allows you to import, or merge, RPM data from existing scenes.

Merge Selected:


Help Menu

About...: this displays some information about the version number.

Help... : this brings up this help.

Authorize...: this opens the Authorization dialog.


3rd Party Renderer Support

PRManager has specific support for Chaos Groups Vray and SplutterFish's Brazil, has been tested with and supports Mental Images Mental Ray, and should support any 3rd Party renderer such as Final Render.

The specific support consists of a set of controls for the renderer which allow you to edit multiple passes renderer parameters simultaneously. This set of controls does not cover the full set of renderer parameters, rather it consists of those controls often needed to be changed en-masse - antialiasing settings, etc. All renderer parameters are stored/restored on a per pass basis, the controls not available in the renderer specific 'Renderers' rollout can be controlled through the standard 3ds max render dialog, on a pass-by-pass basis.

3rd Party Shadow plugins are fully supported.

3rd party lights and cameras - with the exception of Brazils lights and cameras and Vrays VrayLight - are not supported. Please contact requests@grantadam.com to request specific support, and I will do what I can. Please understand this will often depend on the developers of the 3rd party objects.

Brazils Render Pass Control
Since 3rd party renderers are supported per pass, you can setup Brazils Render Pass Control separately per RPManager pass - so the two systems complement each other rather than interfering with each other.

Renderers without specific support
While some renderers parameters are not at this stage editable from within RPManager, RPManager will still save and restore the renderer assigned to this pass, on a pass by pass basis.
To edit the render parameters for a pass simply use the standard max render dialog. Note you can only edit a single pass at a time when using the standard max render dialog, so before modifying the render parameters make sure you have restored a single pass so it's renderer is currently active.


RenderPassManager Limitations/3dsmax Bugs

Output File Formats: RPM cannot set on a per-pass basis cineon, etc. You need to set up a single pass, using the max standard render dialog, to cover the ouput. TGA, TIFF, JPEG can be set per pass, and RLA and RPF using the included (but optionally installed) recompiled RLA.bmi.

There is a bug in max where if you set the output formats setup for targa, tiff or jpeg through the standard render dialog RPM can no longer set these properties - ie if you set 24 bit in the standard render dialog, and a 32 bit pass in RPM, all your passes will be rendered at 24 bit. To avoid this only use RPM to set your output format setups.

Aperture width:
The default render dialog does not display the render aperture width correctly if set using the render pass manager on a per-pass basis, and as such this setting in RPM has almost no effect on your scene. To work around this, manually set your Aperture to the correct value in the default render dialog before setting your camera lens.

Output Devices: Currently no support for output devices. Contact me if you need this.


Miscellaneous Dialogs


Authorization

This dialog facilitates the Authorization of RPManager, converting it from a 3 pass limited demo/light version to an unlimited pass version.

The first field is your hardware lock id - do not change this, copy and paste this value when requesting an auth code.

The second field is where you enter the return code. After entering hit the 'Authorize' button and a success or failure message will appear.

To authorise RPManager, email the HardwareLockID from the top field (copy and paste to make sure the value is correct) to licensing@rpmanager.com
You should receive a return email within 24 hours that includes a license code - enter the value (copy and paste is the quickest and most reliable) in the second field and press the 'Authorize' button. A dialog indicating success or failure will appear.
Assuming the authorisation was successful, close and reopen RPManager and you are done.
A .dat license file has been created in the <3dsmaxroot>/scripts/RPManager directory.


Render Element Merger

This dialog allows you to load render element data that has been previously saved out of RPManager, using the 'Save...' button in the Render Elements (Scanline) Rollout.

After picking a saved Render ElementData File (.rel) you assign what to load by drag and dropping from the pass names in the left treeview list, to the pass names in the right list box.

The Map 1:1 will assign based on pass names, if pass names are consistent between the loaded data and the current scene file.


Output Preferences

Preview Location...: This controls where RPManager stores its preview files:

  • System temp Directory: uses the system temp directory for all preview files.
  • Create Local Directory: this creates a directory that matches the name of the scene file, in the same location as the scene file. Saving your scene under a different name (or just incrementally) will create a new local directory for preveiw file storage.
  • Specify Storage Directory: use the browse button or enter by hand a directory where all preview files will be stored.

History Setting/Keep Preview History Files: with this on RPManager keeps the preview images that are rendered, up to the specifed count. They can be ramplayed later to check the progress of work.

History Setting/Stamping: with this on RPManager stamps the scene name, render time, and frame number onto the preview - note this is only visible if you ramplay or open up a preview frame to view, it is not immediately visible in a render.

Set as defaults: this sets the current parameters, ie preview history, preview location, to be the default for all future RPManager datasets.

Main output in subdirectory...: The output preferences allows you to control the way the main pass auto path generation is handled, mainly for when you are rendering render elements. With this checkbox on the main pass is created in a subdirectory of the passes directory, with the suffix '_Main'.

Root Directory Per Pass: this feature is disabled and may be removed.


External Data Manager

The RPManager Pass Merger dialog allows you to control the external data that can be saved from a RPManager scene.

External data allows you to have many of the parameters that make up a pass saved to external ascii files that can be edited externally to 3dsmax. On opening a scene RPM can check this external data, and if any changes have been made update its passes. You could use this to change the output paths for many scenes using a batch file external to 3dsmax, or change the output resolution of many scenes at once. The next time the scene is opened it can be transparently updated.

Save Pass Data as Ascii: this is the global on/off for this system.

etc.


Auto Build Output Paths System

One of the features of RPManager is the ability to automatically build your pass output paths, and render element output paths, based on a scripted function.

For Pass output, the shipping function throws up a location and file extension requestor, and then in the picked directory it builds directories and output filenames matching pass names.

For Render Elements, the shipping function builds subdirectories labelled with the name of the render element beneath the main Pass outputs directory.

There is also the option of having the main pass output in it's own subdirectory to avoid renderered images and directories mixed in the same 'root' directory.

You may edit this function so the auto build paths feature creates the outputs whatever you want - for example it could query a database to extract where the files should be going, etc.

Editing this, however, does require scripting knowledge.

The file containing the functions is located in your maxRoot/scripts/RPManager directory, and is titled 'RPMbuildOutputPaths.ms'.


How To: Links to explanations.

How To: Explanations of workflow and features.

Below are a series of links to how to tutorials and explanations:

How to authorise RPManager

How to control object visibility per pass

How to have objects not visible in a particular pass cast shadows

How to use the Quick Compositor

How to control Xref Scenes per pass

How to control object properties per pass

How to control lighting per pass

How to assign a callback per pass

How to use the before/after scripts per pass

How to assign renderers

How to control renderer parameters

How to control renderer parameters for renderers that have 'No Access' (ie mental ray, final render)

How to use the renderers presets

How to use the Preview Overrides

How to use the Network rollout

How to control Render Effects and Atmospherics per pass

How to control Render Elements per pass


How To Authorize RPManager

From the Help menu within the RPManger interface pick the 'Authorize...' menu item, which will bring up the dialog seen to the right.

Then email the HardwareLockID from the top field (copy and paste to make sure the value is correct) to licensing@rpmanager.com

You should receive a return email within 24 hours that includes a license code - enter the value (copy and paste is the quickest and most reliable) in the second field and press the 'Authorize' button. A dialog indicating success or failure will appear.

Assuming the authorisation was successful, close and reopen RPManager and you are done.

A RPMLicense.dat file has been created in your <3dsmaxroot>/scripts/RPManager directory.


Untitled Document

Rollouts
Render Pass Manager's interface is built around rollouts, each containing controls and information about a particular section of the rendering pass system. The following pages explain each rollout in detail.


Add Render Elements

This dialog allows you to add render elements. You can select multiple list items and then press the add button, or double click on items to add them.


Render Element Path Inspector

This dialog shows all your Render Element outputs in one place, and allows you to edit individual paths.

This dialog is resizable, but will try to intelligently truncate paths that are too long to fit - as can be seen in the image to the right.

To edit a path, select the pass/path in the upper list box, and then use the 'Browse...' button which brings up a bitmap selector, or click on the path field which puts it into edit mode - enter to complete the edit of the path.


Tab Sytem

To display a rollout simply click on the relevant tab. The current rollout is hidden and the rollout selected is displayed.

Control click on a tab to add the selected rollout to the rollouts currently visible.

Shift-LeftClick on the tab area to bring up the tab control menu - where you can lock the current selection, open the Tab Set Management dialog, or select a previously saved set from the list.

Tab Set Management:
Tab sets allow you to setup presets of tab selections so you can quickly return to setups you use often. For example you may often view the effect and atmospheric rollouts together - using a tab set can save you a mouse click or two.
This dialog allows you to create a set, rename a set, delete a set or redefine an existing tab set. Tab sets are created defined as the current tab selection, so you need to make sure that you have the tabs active that you want to define as a set before you open this dialog.